﻿using Android.App;
using Android.Widget;
using Android.OS;
using Com.Syncfusion.Schedule;
using System.Collections.Generic;
using Android.Graphics;
using Java.Util;
using Java.Lang;
using Com.Syncfusion.Schedule.Enums;

namespace MonthViewAppointments_Android
{
	[Activity(Label = "MonthViewAppointments_Android", MainLauncher = true, Icon = "@mipmap/icon")]
	public class MainActivity : Activity
	{
		SfSchedule schedule;
		ScheduleAppointmentCollection appointmentCollection;

		protected override void OnCreate(Bundle savedInstanceState)
		{
			base.OnCreate(savedInstanceState);

			//creating instance for Schedule
			schedule = new SfSchedule(this);

			//set the appointment collection
			getAppointments();
			schedule.Appointments = appointmentCollection;
			schedule.ScheduleView = ScheduleView.MonthView;
			SetContentView(schedule);

		}

		List<string> subjectCollection = new List<string>();
		List<string> colorCollection = new List<string>();
		List<Calendar> startTimeCollection = new List<Calendar>();
		List<Calendar> endTimeCollection = new List<Calendar>();

		//Creating appointments for ScheduleAppointmentCollection
		private void getAppointments()
		{
			appointmentCollection = new ScheduleAppointmentCollection();
			setColors();
			RandomNumbers();
			setSubjects();
			setStartTime();
			setEndTime();
			for (int i = 0; i < 10; i++)
			{
				ScheduleAppointment scheduleAppointment = new ScheduleAppointment();
				scheduleAppointment.Color = Color.ParseColor(colorCollection[i]);
				scheduleAppointment.Subject = subjectCollection[i];
				scheduleAppointment.StartTime = startTimeCollection[i];
				scheduleAppointment.EndTime = endTimeCollection[i];
				appointmentCollection.Add(scheduleAppointment);
			}
		}
		private void setSubjects()
		{
			subjectCollection = new List<string>();
			subjectCollection.Add("GoToMeeting");
			subjectCollection.Add("Business Meeting");
			subjectCollection.Add("Conference");
			subjectCollection.Add("Project Status Discussion");
			subjectCollection.Add("Auditing");
			subjectCollection.Add("Client Meeting");
			subjectCollection.Add("Generate Report");
			subjectCollection.Add("Target Meeting");
			subjectCollection.Add("General Meeting");
			subjectCollection.Add("Pay House Rent");
			subjectCollection.Add("Car Service");
			subjectCollection.Add("Medical Check Up");
			subjectCollection.Add("Wedding Anniversary");
			subjectCollection.Add("Sam's Birthday");
			subjectCollection.Add("Jenny's Birthday");
		}

		// adding colors collection
		private void setColors()
		{
			colorCollection = new List<string>();
			colorCollection.Add("#FFA2C139");
			colorCollection.Add("#FFD80073");
			colorCollection.Add("#FF1BA1E2");
			colorCollection.Add("#FFE671B8");
			colorCollection.Add("#FFF09609");
			colorCollection.Add("#FF339933");
			colorCollection.Add("#FF00ABA9");
			colorCollection.Add("#FFE671B8");
			colorCollection.Add("#FF1BA1E2");
			colorCollection.Add("#FFD80073");
			colorCollection.Add("#FFA2C139");
			colorCollection.Add("#FFD80073");
			colorCollection.Add("#FF339933");
			colorCollection.Add("#FFE671B8");
			colorCollection.Add("#FF00ABA9");
		}

		List<int> randomNums = new List<int>();
		private void RandomNumbers()
		{
			randomNums = new List<int>();
			Java.Util.Random rand = new Java.Util.Random();
			for (int i = 0; i < 10; i++)
			{
				int randomNum = rand.NextInt((15 - 9) + 1) + 9;
				randomNums.Add(randomNum);
			}
		}
		// adding StartTime collection
		private void setStartTime()
		{

			startTimeCollection = new List<Calendar>();
			Calendar currentDate = Calendar.Instance;
			int count = 0;
			for (int i = -5; i < 5; i++)
			{

				Calendar startTime = (Calendar)currentDate.Clone();
				startTime.Set
				(
					currentDate.Get(CalendarField.Year),
					currentDate.Get(CalendarField.Month),
					currentDate.Get(CalendarField.DayOfMonth) + i,
					randomNums[count],
					0,
					0
				);
				startTimeCollection.Add(startTime);
				count++;
			}
		}

		// adding EndTime collection
		private void setEndTime()
		{
			endTimeCollection = new List<Calendar>();
			Calendar currentDate = Calendar.Instance;
			int count = 0;
			for (int i = -5; i < 5; i++)
			{
				Calendar endTime = (Calendar)currentDate.Clone();
				endTime.Set
				(
					currentDate.Get(CalendarField.Year),
					currentDate.Get(CalendarField.Month),
					currentDate.Get(CalendarField.DayOfMonth) + i,
					randomNums[count] + 1,
					0,
					0
				);
				endTimeCollection.Add(endTime);
				count++;
			}
		}
	}
}

